#ifndef __dragdrop__

declare extern EnableDragDrop(HWND hwndEdit, BOOL fEnable);

#else

class CUnknown
{
	declare virtual QueryInterface(REFIID *riid, void *ppvObject),HRESULT;
	declare virtual AddRef(),ULONG;
	declare virtual Release(),ULONG;
}

// this class represents the text data
// only GetData and QueryGetData methods are implemented
class CDataObject : CUnknown
{
	declare virtual QueryInterface(REFIID *riid, void *ppvObject),HRESULT;

	declare virtual GetData(FORMATETC *pformatetcIn,/*out*/STGMEDIUM *pmedium),HRESULT;
	declare virtual GetDataHere(FORMATETC *pformatetc,/*out*/STGMEDIUM *pmedium),HRESULT;
	declare virtual QueryGetData(FORMATETC *pformatetc),HRESULT;
	declare virtual GetCanonicalFormatEtc(FORMATETC *pformatectIn,/*out*/FORMATETC *pformatetcOut),HRESULT;
	declare virtual SetData(FORMATETC *pformatetc,STGMEDIUM *pmedium,BOOL fRelease),HRESULT;
	declare virtual EnumFormatEtc(DWORD dwDirection,/*out*/IEnumFORMATETC *ppenumFormatEtc),HRESULT;
	declare virtual DAdvise(FORMATETC *pformatetc,DWORD advf,IAdviseSink *pAdvSink,/*out*/DWORD *pdwConnection),HRESULT;
	declare virtual DUnadvise(DWORD dwConnection),HRESULT;
	declare virtual EnumDAdvise(/*out*/IEnumSTATDATA *ppenumAdvise),HRESULT;
	// edit control selection
	int m_selstart;
	int m_selend;
	// edit control handle. Call GetProp(m_hwnd, L"CDropSource") to get pointer to CDropSource
	HWND m_hwnd;
}

// this class is to accept dropped text
class CDropTarget : CUnknown // GetProp(hwnd, L"CDropSource")
{
	declare virtual QueryInterface(REFIID *riid, void *ppvObject),HRESULT;

	// call pDataObj->QueryInterface(&_IID_IMyDataObject) to check if IDataObject == CDataObject
	declare virtual DragEnter(IDataObject *pDataObj,DWORD grfKeyState,POINTL pt byval,DWORD *pdwEffect),HRESULT;
	declare virtual DragOver(DWORD grfKeyState,POINTL pt byval,DWORD *pdwEffect),HRESULT;
	declare virtual DragLeave(),HRESULT;
	declare virtual Drop(IDataObject *pDataObj,DWORD grfKeyState,POINTL pt byval,DWORD *pdwEffect),HRESULT;

	// source data object, it may be CDataObject
	IDataObject *m_pDataObj; // initialized in CDropTarget::DragEnter
	HWND m_hwnd; // edit control
	int  m_charindex; // drop text here
}

// and this one is the source of drag-drop operation
class CDropSource : CUnknown
{
	declare virtual QueryInterface(REFIID *riid, void *ppvObject),HRESULT;

	declare virtual QueryContinueDrag(BOOL fEscapePressed, DWORD grfKeyState),HRESULT;
	declare virtual GiveFeedback(DWORD dwEffect),HRESULT;

	declare LoadSelection();
	declare IsTextSelected(),BOOL;
	declare HitTest(LPARAM pt),int;
	declare OverSelectedText(int charIndex),BOOL;
	declare DoDragDrop();

	CDataObject m_dataobj;
	CDropTarget m_droptarget;
	WNDPROC originalproc;
	BOOL    m_enabled;
	BOOL    mousedown;
}

#endif
